
/*  This file is included by all the modules in the library and defines
    all functions, internal and external.  If GNARL is defined,
    internal function names are prefixed with DCDF__ to avoid name
    clashes with user functions.  To call internal functions, (some of
    which are very useful) simply prefix the name with DCDF__, or
    compile without GNARL defined and call with their internal
    names.  */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "dcdflib.h"                  /* User accessible functions */

#ifdef GNARL
#define algdiv   DCDF__algdiv
#define alngam   DCDF__alngam
#define alnrel   DCDF__alnrel
#define apser    DCDF__apser
#define basym    DCDF__basym
#define bcorr    DCDF__bcorr
#define betaln   DCDF__betaln
#define bfrac    DCDF__bfrac
#define bgrat    DCDF__bgrat
#define bpser    DCDF__bpser
#define bratio   DCDF__bratio
#define brcmp1   DCDF__brcmp1
#define brcomp   DCDF__brcomp
#define bup      DCDF__bup
#define cumbet   DCDF__cumbet
#define cumbin   DCDF__cumbin
#define cumchi   DCDF__cumchi
#define cumchn   DCDF__cumchn
#define cumf     DCDF__cumf
#define cumfnc   DCDF__cumfnc
#define cumgam   DCDF__cumgam
#define cumnbn   DCDF__cumnbn
#define cumnor   DCDF__cumnor
#define cumpoi   DCDF__cumpoi
#define cumt     DCDF__cumt
#define dbetrm   DCDF__dbetrm
#define devlpl   DCDF__devlpl
#define dexpm1   DCDF__dexpm1
#define dinvnr   DCDF__dinvnr
#define E0000    DCDF__E0000
#define dinvr    DCDF__dinvr
#define dstinv   DCDF__dstinv
#define dlanor   DCDF__dlanor
#define dln1mx   DCDF__dln1mx
#define dln1px   DCDF__dln1px
#define dlnbet   DCDF__dlnbet
#define dlngam   DCDF__dlngam
#define dstrem   DCDF__dstrem
#define dt1      DCDF__dt1
#define E0001    DCDF__E0001
#define dzror    DCDF__dzror
#define dstzr    DCDF__dstzr
#define erf1     DCDF__erf1
#define erfc1    DCDF__erfc1
#define esum     DCDF__esum
#define exparg   DCDF__exparg
#define fpser    DCDF__fpser
#define gam1     DCDF__gam1
#define gaminv   DCDF__gaminv
#define gamln    DCDF__gamln
#define gamln1   DCDF__gamln1
#define Xgamm    DCDF__Xgamm
#define grat1    DCDF__grat1
#define gratio   DCDF__gratio
#define gsumln   DCDF__gsumln
#define psi      DCDF__psi
#define rcomp    DCDF__rcomp
#define rexp     DCDF__rexp
#define rlog     DCDF__rlog
#define rlog1    DCDF__rlog1
#define spmpar   DCDF__spmpar
#define stvaln   DCDF__stvaln
#define fifdint  DCDF__fifdint
#define fifdmax1 DCDF__fifdmax1
#define fifdmin1 DCDF__fifdmin1
#define fifdsign DCDF__fifdsign
#define fifidint DCDF__fifidint
#define fifmod   DCDF__fifmod
#define ftnstop  DCDF__ftnstop
#define ftnstop  DCDF__ftnstop
#define ipmpar   DCDF__ipmpar
#endif

extern double algdiv(double*,double*);
extern double alngam(double*);
extern double alnrel(double*);
extern double apser(double*,double*,double*,double*);
extern double basym(double*,double*,double*,double*);
extern double bcorr(double*,double*);
extern double betaln(double*,double*);
extern double bfrac(double*,double*,double*,double*,double*,double*);
extern void bgrat(double*,double*,double*,double*,double*,double*,int*i);
extern double bpser(double*,double*,double*,double*);
extern void bratio(double*,double*,double*,double*,double*,double*,int*);
extern double brcmp1(int*,double*,double*,double*,double*);
extern double brcomp(double*,double*,double*,double*);
extern double bup(double*,double*,double*,double*,int*,double*);
extern void cumbet(double*,double*,double*,double*,double*,double*);
extern void cumbin(double*,double*,double*,double*,double*,double*);
extern void cumchi(double*,double*,double*,double*);
extern void cumchn(double*,double*,double*,double*,double*);
extern void cumf(double*,double*,double*,double*,double*);
extern void cumfnc(double*,double*,double*,double*,double*,double*);
extern void cumgam(double*,double*,double*,double*);
extern void cumnbn(double*,double*,double*,double*,double*,double*);
extern void cumnor(double*,double*,double*);
extern void cumpoi(double*,double*,double*,double*);
extern void cumt(double*,double*,double*,double*);
extern double dbetrm(double*,double*);
extern double devlpl(double [],int*,double*);
extern double dexpm1(double*);
extern double dinvnr(double *p,double *q);
extern void E0000(int,int*,double*,double*,unsigned long*,
                         unsigned long*,double*,double*,double*,
                         double*,double*,double*,double*);
extern void dinvr(int*,double*,double*,unsigned long*,unsigned long*);
extern void dstinv(double*,double*,double*,double*,double*,double*,
                   double*);
extern double dlanor(double*);
extern double dln1mx(double*);
extern double dln1px(double*);
extern double dlnbet(double*,double*);
extern double dlngam(double*);
extern double dstrem(double*);
extern double dt1(double*,double*,double*);
extern void E0001(int,int*,double*,double*,double*,double*,
                  unsigned long*,unsigned long*,double*,double*,
                  double*,double*);
extern void dzror(int*,double*,double*,double*,double *,
                  unsigned long*,unsigned long*);
extern void dstzr(double *zxlo,double *zxhi,double *zabstl,double *zreltl);
extern double erf1(double*);
extern double erfc1(int*,double*);
extern double esum(int*,double*);
extern double exparg(int*);
extern double fpser(double*,double*,double*,double*);
extern double gam1(double*);
extern void gaminv(double*,double*,double*,double*,double*,int*);
extern double gamln(double*);
extern double gamln1(double*);
extern double Xgamm(double*);
extern void grat1(double*,double*,double*,double*,double*,double*);
extern void gratio(double*,double*,double*,double*,int*);
extern double gsumln(double*,double*);
extern double psi(double*);
extern double rcomp(double*,double*);
extern double rexp(double*);
extern double rlog(double*);
extern double rlog1(double*);
extern double spmpar(int*);
extern double stvaln(double*);
extern double fifdint(double);
extern double fifdmax1(double,double);
extern double fifdmin1(double,double);
extern double fifdsign(double,double);
extern long fifidint(double);
extern long fifmod(long,long);
extern void ftnstop(char*);
extern int ipmpar(int*);
