
#include <stdio.h>
#include <math.h>
#include "../doc/dcdflib.h"

static double Xsq[] = { 2.706, 4.605, 6.251, 7.779, 9.236,
			10.645, 12.017, 13.362, 14.684, 15.987, -1 };

#define DF

int main()
{
int	i;
	for (i = 0; Xsq[i] > 0.0; i++) {
	    int which, status;
	    double p, q, dof, x, bound;

#ifdef DF
	    which = 3;
	    p = 1 - (q = 0.1);
#else
	    which = 1;
	    dof = i + 1;
#endif
	    x = Xsq[i];
	    cdfchi(&which, &p, &q, &x, &dof, &status, &bound);
            printf ("%3d %8.3f ", i, Xsq[i]);
	    if (status == 0) {
#ifdef DF
		q = dof;
#endif
                printf ("%8.3f\n", q);
	    } else {
                printf(" S = %3d\n", status);
	    }
	}
        putchar ('\n');
    return 0;
}
